100 REMark ** Converting a Assembler/Workbench, Disassembly
110 REMark ** To a re-assembleable state
120 REMark ** 1/12/90
130 REMark
140 REMark ** Best if complied
150 REMark
160 REMark **********************************************************
170 REMark *                     Phase One                          *
180 REMark *                                                        *
190 REMark *  Convert all PC relative and Absolute jumps to Labels  *
200 REMark *             and create a label file                    *
210 REMark **********************************************************
220 REMark
230 REMark ** Last line is NOT processed, So Disassemble a few bytes
240 REMark ** more than you need.
250 DIM label$(32000),source$(50),work$(50)
260 MODE 4
270 CLS
280 label$="":REMark All labels stored here
290 PRINT "Source and Work drives should be different if possible"
300 PRINT "RAM disks or EDITOR files for faster processing"
310 PRINT
320 PRINT "Press ENTER alone to abort"
330 PRINT
340 INPUT "Enter Source device name ";source$
350 IF source$="" THEN STOP
360 INPUT "Enter Work device name ";work$
370 IF work$="" THEN STOP
380 INPUT "Enter filename ";file$
390 IF file$="" THEN STOP
400 OPEN_IN#3,source$&file$
410 DELETE work$&file$&"_PH1"
420 OPEN_NEW#4,work$&file$&"_PH1" :REMark Open input and output files
430 REMark ** A$ is the line of dissembly you are working on
440 REMark ** and b$ is the next line
450 INPUT#3,a$
460 REPeat loop
470  IF EOF(#3) THEN EXIT loop
480  INPUT#3,b$
490  REMark ** Check for two line disassembly
500  REMark ** OP_POS is the position of the first charcter of Opcode
510  op_pos=26
520  IF b$(1 TO 8)="        "
530   op_pos=38
540   a$=a$&b$(11 TO )
550   INPUT#3,b$
560  END IF
570  REMark ** Illegal Instructions
580  IF a$(26 TO 32)="ILLEGAL"
590   x$=a$(11 TO 14)
600   a$(26 TO 46)="dc.w      $"&x$&"      "
610  END IF
620  REMark ** Remove  HEX dump section
630  x=" " INSTR a$(11 TO )
640  a$(11 TO )=a$(op_pos TO )
650  REMark ** Remove ASCII from ends
660  x=" " INSTR a$(36 TO )
670  IF x
680   a$=a$(1 TO 35+(x-1))
690  END IF
700  REMark ** PC relative instructions
710  x="(PC)" INSTR a$
720  IF x
730   a$(x-9)="L"
740   a$=a$(1 TO 21)&a$(23 TO 29)&a$(34 TO )
750   x$=a$(21 TO 28):REMark x$=label name
760   IF NOT x$ INSTR label$
770    label$=label$&x$
780   END IF
790  END IF
800  x="(PC," INSTR a$
810  IF x
820   a$(x-9)="L"
830   a$=a$(1 TO 21)&a$(23 TO )
840   x$=a$(21 TO 28):REMark x$=label name
850   IF NOT x$ INSTR label$
860    label$=label$&x$
870   END IF
880  END IF
890  REMark ** Deal with Branches and Jumps
900  IF a$(11) INSTR "bjd" THEN Branch_Test
910  REMark ** Finished checks
920  PRINT#4,a$
930  PRINT a$
940  a$=b$
950 END REPeat loop
960 label$=label$&CHR$(0):REMark End marker to prevent error in phase two
970 CLOSE#3
980 CLOSE#4
990 PRINT "Phase One complete."
1000 PRINT:PRINT
1010 REMark *********************************************************
1020 REMark *                     PHASE TWO                         *
1030 REMark *                                                       *
1040 REMark *     Scan the Phase One file, remove addresses and     *
1050 REMark *                replace with Labels                    *
1060 REMark *********************************************************
1070 REMark
1080 PRINT "The Assembly listing will now be created on ";source$;" with the"
1090 PRINT "suffix _ASM, If the source drive will not have sufficent free space,"
1100 PRINT "change it now.  Press any key to continue..."
1110 PRINT:PRINT
1120 PAUSE
1130 OPEN_IN#3,work$&file$&"_PH1"
1140 DELETE source$&file$&"_ASM"
1150 OPEN_NEW#4,source$&file$&"_ASM"
1160 REPeat loop
1170  IF EOF(#3) THEN EXIT loop
1180  INPUT#3,a$
1190  REMark ** Check to see if address is in label list
1200  x$="L"&a$(2 TO 8)
1210  lab_point=x$ INSTR label$
1220  IF lab_point
1230   a$(1)="L"
1240   REMark ** Now remove this label from the list
1250   label$=label$(1 TO lab_point-1)&label$(lab_point+8 TO )
1260  ELSE
1270   a$(1 TO 8)="        "
1280  END IF
1290  PRINT a$
1300  PRINT#4,a$
1310 END REPeat loop
1320 REMark ** Produce a unreferanced label list
1330 FOR x=1 TO 3:PRINT#4
1340 PRINT#4,";"; TO 10;"Unreferanced Label List."
1350 PRINT#4
1360 REPeat loop
1370  IF LEN(label$)>8
1380   PRINT#4,";"; TO 20;label$(1 TO 8)
1390   label$=label$(9 TO )
1400  ELSE
1410   EXIT loop
1420  END IF
1430 END REPeat loop
1440 CLOSE#3
1450 CLOSE#4
1460 PRINT:PRINT
1470 PRINT "File conversion complete."
1480 STOP
1490 REMark
1500 REMark ******************************************************
1510 REMark *                  BRANCH TESTS                      *
1520 REMark ******************************************************
1530 DEFine PROCedure Branch_Test
1540 REMark ** First check for Bit test and Divide instructions
1550 IF a$(11 TO 14) INSTR "btstbchgbclrbsetdivsdivu" THEN RETurn
1560 REMark ** Next check for Define Constant directives
1570 IF a$(11 TO 12)="dc" THEN RETurn
1580 REMark ** If you have got this far, it must be a Branch
1590 REMark ** or jump instruction
1600 REMark
1610 REMark ** DBxx Instructions
1620 IF a$(11 TO 12)="db"
1630  a$(24)="L"
1640  a$=a$(1 TO 24)&a$(26 TO )
1650  x$=a$(24 TO 31)
1660  REMark ** Add label to list if not already there
1670  IF NOT x$ INSTR label$
1680   label$=label$&x$
1690  END IF
1700 REMark ** Jump and Branch Instructions
1710 ELSE
1720  IF a$(21)="$"
1730   IF NOT "(a" INSTR a$
1740    a$(21)="L"
1750    a$=a$(1 TO 21)&a$(23 TO )
1760    x$=a$(21 TO 28)
1770    IF NOT x$ INSTR label$
1780     label$=label$&x$
1790    END IF
1800   END IF
1810  END IF
1820 END IF
1830 END DEFine Branch_Test
